// Copyright (c) 2009 by Andrey Mirtchovski <mirtchovski@gmail.com>

/* Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * ANDREY MIRTCHOVSKI AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

var updateInterval;
var updateTimer;
var description;
var fadeTimer = null;
var buildVersion;
var availVersion;
var useGrowl = false;
var useGrowlSticky = false;
var click = "http://www.avantlink.com/click.php?mi=10417&amp;tt=cl&amp;pw=5177&amp;url=http%3A%2F%2Fwww.brociety.com";
var datasrc = "http://www.brociety.com";

function setTimer(time) {
	if(updateTimer) {
		clearInterval(updateTimer);
		updateTimer = null;
	}
	updateTimer = setInterval('updateHandler()', time);
}

function stopTimer() {
	if(updateTimer) {
		clearInterval(updateTimer);
		updateTimer = null;
	}
}

function refresh(l) {
	var er;
	SimpleAJAXCall(
		datasrc,
		function(xml) {
			// convert the HTML to an XML DOM object
			xml = getDOMfromXML(xml);
			var it = document.getElementById('itemTitle');
			var pt = document.getElementById('itemPrice');
			var st = document.getElementById('itemReduced');
			var pic = document.getElementById('itemImage');
			var nl = xml.getElementsByTagName('div');
			var itemIsNew = false;
            var img;

			for(var i = 0; i < nl.length; i++) {
				if(nl[i].id == 'item_description') {
                    var name = nl[i].getElementsByTagName('h2')[0].innerHTML;
                    if(name.lastIndexOf(':') > 0) {
                        name = name.substring(0, name.lastIndexOf(':'));
                    }
                    if(name.split(" ").join("") != it.innerHTML.split(" ").join("")) {
                        itemIsNew = true;
                    }
                    it.innerHTML = name;
                    
					description = nl[i].getElementsByTagName('p')[0].innerHTML;
                } else if(nl[i].id == 'price') {
					pt.innerHTML = nl[i].innerHTML;
				} else if(nl[i].id == 'percent_off') {
					st.innerHTML = nl[i].innerHTML;
				} else if(nl[i].id == 'item_image') {
                    img = nl[i].getElementsByTagName('img');
				}
			}
			
			if(pic.style.opacity < 0.1) {
				var fadeHandler = function(a, c, s, f){ pic.style.opacity = c; };
				fadeTimer = new AppleAnimator(1000, 13, 0.0, 1.0, fadeHandler);
				fadeTimer.start();
			}
            
            if(itemIsNew) {
                delete pic.src;
                pic.src = img[0].getAttribute('src');
                if(pic.src.substr(0,4) == 'file') {
                    pic.src = datasrc + pic.src.substr(6);
                }
            }
            if(itemIsNew && useGrowl) {
                var command = './growlnotify -n "Brociety" --image Icon.png -m "' + eq(it.innerHTML) + '" ' +
                    (useGrowlSticky ? '-s ' : '') +
                    '-o "' + click + '" ' + eq(pt.innerHTML);
                widget.system(command, function (meh) {/* do nothing */});
            }
		},
		'GET',
        null
	);
}

function getDOMfromXML(xml) {
	var d = document.createElement('div');
	xml = xml.substring(xml.indexOf('<body') + xml.substring(xml.indexOf('<body')).indexOf('>')+1);
	xml = xml.substring(0, xml.lastIndexOf('</body>'));
    //remove all other mentionings of "</body>": bc.com has broken html
    xml = xml.replace(/<\/body>/g, '');
    xml = xml.replace(/<body bgcolor[^>]*>/g, '');
	d.innerHTML = xml;
	
	return d;
}

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	
	var popup = document.getElementById('popup');
    var cb = document.getElementById('growlCheckbox');
    var cb1 = document.getElementById('growlCheckbox1');
	if(window.widget) {
		var ui = widget.preferenceForKey("updateInterval");
		if (ui && ui.length > 0) {
			popup.value = ui;
		}

        var ug = widget.preferenceForKey("brocietyuseGrowl");
        if(ug != null) {
            cb.checked = ug;
            useGrowl = ug;
        }
        var ugs = widget.preferenceForKey("brocietyuseGrowlSticky");
        if(ugs != null) {
            cb1.checked = ugs;
            useGrowlSticky = ugs;
        }
    }
    updateInterval = parseInt(popup.value) * 1000;
    setTimer(updateInterval);
    refresh(1);
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
	stopTimer();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    if(useGrowl == false) {
        stopTimer();
    }
}

function show()
{		
	var ui = document.getElementById("popup");
    
	setTimeout('refresh();', 250);
	
    updateInterval = parseInt(ui.options[ui.selectedIndex].value) * 1000;
    setTimer(updateInterval);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    getVersion();

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	stopTimer();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	var ui = document.getElementById("popup");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	refresh();
    updateInterval = parseInt(ui.options[ui.selectedIndex].value) * 1000;
    setTimer(updateInterval);
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function visitPage(event)
{
	var websiteURL = click;
	widget.openURL(websiteURL);
}

function visitCopyrightPage(event)
{
	var websiteURL = "http://www.brociety.com/brociety/copyright.html";
	widget.openURL(websiteURL);
}

function emailAuthor(event)
{
	var websiteURL = "mailto:mirtchovski@gmail.com?subject=Brociety%20Widget";
	// Show website code
	widget.openURL(websiteURL);
}


function emailMouseOver(event)
{
	var text = document.getElementById("emailText");
	text.style.textDecoration = 'underline';
}

function emailMouseOut(event)
{
	var text = document.getElementById("emailText");
	text.style.textDecoration = 'none';
}
function copyMouseOver(event)
{
	var text = document.getElementById("copyrightTitle");
	text.style.textDecoration = 'underline';
}

function copyMouseOut(event)
{
	var text = document.getElementById("copyrightTitle");
	text.style.textDecoration = 'none';
}

function titleMouseOver(event)
{
	var text = document.getElementById("itemTitle");
	text.style.textDecoration = 'underline';
}


function titleMouseOut(event)
{
	var text = document.getElementById("itemTitle");
	text.style.textDecoration = 'none';
}


function titleClick(event)
{
	var websiteURL = click;
	widget.openURL(websiteURL);
}

function glassClick(event)
{
    refresh();
}


function setPrefs(event)
{
	var ui = document.getElementById('popup');
	
    if(window.widget) {
		widget.setPreferenceForKey(ui.value, "updateInterval");
	}
	updateInterval = parseInt(ui.options[ui.selectedIndex].value*1000);
}

function updateHandler(animation, current, start, finish)
{
	refresh();
}

function descOver(event)
{
    var img = document.getElementById("itemImage");
	var txt = document.getElementById("itemDescription");
	var box = document.getElementById("box");
	
	txt.innerHTML = description;
	box.style.opacity = 1.0;

	if(fadeTimer)
		fadeTimer.stop();
	
	var fadeHandler = function(a, c, s, f){ img.style.opacity = c;};
	fadeTimer = new AppleAnimator(1000, 13, parseFloat(img.style.opacity), 0.0, fadeHandler);
	fadeTimer.start();
}

function descOut(event)
{
	var img = document.getElementById("itemImage");

	if(fadeTimer)
		fadeTimer.stop();
	
	var fadeHandler = function(a, c, s, f){ img.style.opacity = c;};
	fadeTimer = new AppleAnimator(1000, 13, parseFloat(img.style.opacity), 1.0, fadeHandler);
	fadeTimer.start();
}

function visitVers(event)
{
	var websiteURL = "http://www.mirtchovski.com/code/widgets.html";
	widget.openURL(websiteURL);
}


function versionMouseOut(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'none';
}

function versionMouseOver(event)
{
	var text = document.getElementById("newVersion");
	text.style.textDecoration = 'underline';
}

function growlSelectorfun(event)
{
    var sel = document.getElementById("growlCheckbox");
    useGrowl = sel.checked;
    
    if(window.widget) {
		widget.setPreferenceForKey(useGrowl, "brocietyuseGrowl");
	}
}

function growlSelectorSticky(event)
{
    var sel = document.getElementById("growlCheckbox1");
    useGrowlSticky = sel.checked;
    
    if(window.widget) {
		widget.setPreferenceForKey(useGrowlSticky, "brocietyuseGrowlSticky");
	}  
}

function growlClick(event)
{
	var websiteURL = "http://growl.info";
	// Show website code
	widget.openURL(websiteURL);
}

function growlMouseOver(event)
{
	var text = document.getElementById("growlText");
	text.style.textDecoration = 'underline';
}

function growlMouseOut(event)
{
	var text = document.getElementById("growlText");
	text.style.textDecoration = 'none';
}

function eq(str) {
    /* escape quotes */
    s = str.replace(/\'/g, "\'");
    s = s.replace(/\$/g, "\\\$");
    return s.replace(/\"/g, '\\\"');
}
